/**
 * \file
 *
 * \brief PLLǗ
 *
 * 쌠 (c) 2010-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef CLK_PLL_H_INCLUDED
#define CLK_PLL_H_INCLUDED

#include "parts.h"
#include "conf_clock.h"

#if SAM3S
# include "sam3s/pll.h"
#elif SAM3XA
# include "sam3x/pll.h"
#elif SAM3U
# include "sam3u/pll.h"
#elif SAM3N
# include "sam3n/pll.h"
#elif SAM4S
# include "sam4s/pll.h"
#elif SAM4E
# include "sam4e/pll.h"
#elif SAM4L
# include "sam4l/pll.h"
#elif (UC3A0 || UC3A1)
# include "uc3a0_a1/pll.h"
#elif UC3A3
# include "uc3a3_a4/pll.h"
#elif UC3B
# include "uc3b0_b1/pll.h"
#elif UC3C
# include "uc3c/pll.h"
#elif UC3D
# include "uc3d/pll.h"
#elif (UC3L0128 || UC3L0256 || UC3L3_L4)
# include "uc3l/pll.h"
#elif XMEGA
# include "xmega/pll.h"
#else
# error Unsupported chip type
#endif

/**
 * \ingroup clk_group
 * \defgroup pll_group PLLǗ
 *
 * ̌QߏPLĽ`ԐݒƋ/֎~Ɋ֘A֐ƒ`܂݂܂BPLL
 * ͓͐M( \em )ACӑIŌ`Ԑݒ\ \em  ɂ
 * g𕪎ǍɌ`Ԑݒ\ \em { ɂĎg{
 * B
 *
 * ޲͓͕xA1ȊȎ̔@Ȃ镪l̎w\
 * sɋA܂B޲͓͂Əo͂̐M̎g͈͂ɗlXȐ
 * ܂B
 *
 * \par : ҰPLL0\ݒ
 *
 * ȉ̗͏ňꗗɂ`ԐݒقpĎw肳Ұgp
 * PLL0`Ԑݒ肵ċ@܂B
 * \code
	pll_enable_config_defaults(0); \endcode
 *
 * `Ԑݒ肷ɂ́AҰpPLL0ALш敝(UC3A3LPLL
 * CӑI)̂悤ȓ@\֎~̂ɂ̏菇gp邱Ƃł
 * B
 * \code
	struct pll_config pllcfg;
	if (pll_is_locked(pll_id)) {
		return;	// PLL͊ɑs
	}
	pll_enable_source(CONFIG_PLL0_SOURCE);
	pll_config_defaults(&pllcfg, 0);
	pll_config_set_option(&pllcfg, PLL_OPT_WBM_DISABLE);
	pll_enable(&pllcfg, 0);
	pll_wait_for_lock(0); \endcode
 *
 * Ō̊֐Ăяo߂ƁAPLL0͎弽 ۯƂĎgp鏀
 * ܂B
 *
 * \section pll_group_config `Ԑݒ
 *
 * ePLL͉p̌`Ԑݒ̧قňȉ̌`ԐݒقɂČ߂Ұ
 * ꎮ܂B
 *   - \b CONFIG_PLLn_SOURCE: PLL \a n ̓͂ɐڑۯB
 *     #pll_source 񋓂ɂĒ`l1łȂ΂Ȃ܂B
 *   - \b CONFIG_PLLn_MUL: PLL \a n ̊{(ٰߕ)
 *     \a n.
 *   - \b CONFIG_PLLn_DIV: PLL \a n ͕̊
 *
 * ̌`Ԑݒقpll_config_defaults()pll_get_default_rate()Ăяo
 * ̌ʂ߂܂B
 *
 * @{
 */

//! \name ߓLPLL
//@{
/**
 * \def PLL_MAX_STARTUP_CYCLES
 * \brief ᑬۯł̍őPLLn
 */
/**
 * \def NR_PLLS
 * \brief ߏPLL
 */

/**
 * \def PLL_MIN_HZ
 * \brief PLL邱Ƃłŏg
 */
/**
 * \def PLL_MAX_HZ
 * \brief PLL邱Ƃłőg
 */
/**
 * \def PLL_NR_OPTIONS
 * \brief PLLCӑIޯĐ
 */
//@}

/**
 * \enum pll_source
 * \brief PLLۯ
 */

//! \name PLL`Ԑݒ
//@{

/**
 * \struct pll_config
 * \brief PLL`Ԑݒʰ޳L\
 *
 * ̍\݂̂͌PLL`Ԑݒ\1ȏ޲Ll܂݂܂B̍\
 * ̂̓e͈ʓIɊՖɈقȂAgp҂PLL`ԐݒAPIʂƂȂ
 * ̗̈ɂ౸ׂł͂܂B
 */

/**
 * \fn void pll_config_init(struct pll_config *cfg,
 *              enum pll_source src, unsigned int div, unsigned int mul)
 * \brief WҰPLL`Ԑݒ
 *
 * \note ̊֐͔ɏȂԂŌĂ΂AʏAҰƉ肳
 *       邽߁Aײ݂Œ`邩܂B̲ײ݉͂̂悤ȏꍇ
 *       ɺޗʂȂ茸炵܂B
 *
 * \param  cfg PLL`Ԑݒ
 * \param  src PLL̓͂ƂĎgp锭U
 * \param  div PLL͕
 * \param  mul PLLٰߕ({)
 *
 * \return \a src ̎g(\a mul / \a div){PLL𑖍s`Ԑݒ
 */
/**
 * \def pll_config_defaults(cfg, pll_id)
 * \brief ҰpPLL`Ԑݒ菉
 *
 * ̊֐߂A\a cfg CONFIG_PLLx_SOURCE̎g(CONFIG_PLLx_MUL /
 *  CONFIG_PLLx_DIV){PLL𑖍s`Ԑݒ܂݂܂B
 *
 * \param  cfg    ׂPLL`Ԑݒ
 * \param  pll_id PLLɑ΂gp
 */
/**
 * \def pll_get_default_rate(pll_id)
 * \brief \a pll_id Hzł̊葬x擾
 */
/**
 * \fn void pll_config_set_option(struct pll_config *cfg,
 *              unsigned int option)
 * \brief \a cfg `Ԑݒ \a option PLLCӑIޯĂݒ
 *
 * \param  cfg    ύXׂPLL`Ԑݒ
 * \param  option ݒ肳PLLCӑIޯ
 */
/**
 * \fn void pll_config_clear_option(struct pll_config *cfg,
 *              unsigned int option)
 * \brief \a cfg `Ԑݒ \a option PLLCӑIޯĂ
 *
 * \param  cfg    ύXׂPLL`Ԑݒ
 * \param  option PLLCӑIޯ
 */
/**
 * \fn void pll_config_read(struct pll_config *cfg, unsigned int pll_id)
 * \brief \a pll_id ̌݊Ȍ`Ԑݒǂݍ
 *
 * \param  cfg    ݊Ȍ`Ԑݒi[邽߂̌`Ԑݒ޼ު
 * \param  pll_id PLL̎ʎq
 */
/**
 * \fn void pll_config_write(const struct pll_config *cfg,
 *              unsigned int pll_id)
 * \brief \a pll_id  \a cfg `Ԑݒ
 *
 * \param  cfg    ɂPLL`Ԑݒ\`Ԑݒ޼ު
 * \param  pll_id XVPLL̎ʎq
 */

//@}

//! \name PLLʰ޳ł̑ݍp
//@{
/**
 * \fn void pll_enable(const struct pll_config *cfg,
 *              unsigned int pll_id)
 * \brief \a cfg `Ԑݒ̊ \a pll_id PLL̋
 *
 * \param  cfg    ׂPLL`Ԑݒ
 * \param  pll_id PLL̎ʎq
 */
/**
 * \fn void pll_disable(unsigned int pll_id)
 * \brief \a pll_id ɂĎʂPLL֎~
 *
 * ̊֐Ă΂ꂽA \a pll_id ɂĎʂPLL֎~܂Bʰ޳
 * Ŋi[ꂽPLL`Ԑݒ͂ɂĉeyڂ邩ꂸÂɌĂяo
 * œ`Ԑݒɉ񕜂邱ƂKvȏꍇAPLL֎~O
 * pll_config_read()sA܂PLLɏꂽŌ̌`ԐݒL邩̂
 * 炩ׂłB
 *
 * \param  pll_id ֎~PLLɎʎq
 */
/**
 * \fn bool pll_is_locked(unsigned int pll_id)
 * \brief PLLŒ艻Ă邩ۂ𔻒
 *
 * \param  pll_id ׂPLL̎ʎq
 *
 * \retval true  PLL͌Œ艻AۯƂĎgp鏀Ă܂B
 * \retval false PLL͖Œ艻ꂸA܂B
 */
/**
 * \fn void pll_enable_source(enum pll_source src)
 * \brief PLL̋
 * ɑsĂȂȂA܂B
 *
 * \param  src PLL̎ʎq
 */
/**
 * \fn void pll_enable_config_defaults(unsigned int pll_id)
 * \brief `ԐݒPLL
 *        PLLɌŒ艻ĂȂ΁APLL܂B
 *
 * \param  pll_id PLL̎ʎq
 */

/**
 * \brief Œ艻ɂȂ܂ \a pll_id PLLҋ@
 *
 * \todo ȋ҂Ƽђ~邽߂ɐԂgpĂB
 *
 * \param  pll_id ҂PLL̎ʎq
 *
 * \retval STATUS_OK PLL͍Œ艻Ă܂B
 * \retval ERR_TIMEOUT Œ艻ɂȂPLLҋ@̐Ԓ
 */
static inline int pll_wait_for_lock(unsigned int pll_id)
{
	Assert(pll_id < NR_PLLS);

	while (!pll_is_locked(pll_id)) {
		/* Ȃ */
	}

	return 0;
}

//@}
//! @}

#endif /* CLK_PLL_H_INCLUDED */
