/**
 * \file
 *
 * \brief AVR XMEGA XCL(XMEGA_H)ײ
 *
 * 쌠 (C) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include <stdint.h>
#include "interrupt.h"
#include "compiler.h"
#include "parts.h"

#include "xcl.h"
#include "sysclk.h"
#include "sleepmgr.h"

#if defined(CONFIG_XCL_CALLBACK_ENABLE) || defined(__DOXYGEN__)

/* ! \internal XCLĂі߂֐̋ǏL */
static xcl_callback_t xcl_unf_callback;

/**
 * \internal
 * \brief XCLp荞ݏ
 *
 * ̊֐XCLł̊荞݂XCLĂі߂֐Ăт܂B
 *
 * \note ̊荞ݏٰ(ISR)conf_xcl.hCONFIG_XCL_CALLBACK_ENABLE
 *       ̎ɂ錾܂B
 */
ISR(XCL_UNF_vect)
{
	Assert(xcl_unf_callback != NULL);
	xcl_unf_callback();
}

/**
 * \brief XCLꊄ荞݌Ăі߂֐ݒ
 *
 * ̊֐͊荞݌Ăі߂֐̐ݒƕύXĂяoɋ܂BĂі߂
 * ̂ȂŁAײޓ̊荞ݏ͊荞ݗv׸ނ邾łB
 *
 * \note ̊֐conf_xcl.hCONFIG_XCL_CALLBACK_ENABLE̎ɂp
 *       \łB
 *
 * \param  callback Ăі߂֐ւ̎Q
 */
void xcl_set_unf_interrupt_callback(xcl_callback_t callback)
{
	xcl_unf_callback = callback;
}

/* ! \internal XCLr/ߊlĂі߂֐̋ǏL */
static xcl_callback_t xcl_cc_callback;

/**
 * \internal
 * \brief XCLr܂͕ߊlp荞ݏ
 *
 * ̊֐XCL̔r܂͕ߊlł̊荞݂A֘AĂі߂֐
 * т܂B
 *
 * \note ̊荞ݏٰ(ISR)conf_xcl.hCONFIG_XCL_CALLBACK_ENABLE
 *       ̎ɂ錾܂B
 */
ISR(XCL_CC_vect)
{
	Assert(xcl_cc_callback != NULL);
	xcl_cc_callback();
}

/**
 * \brief XCLr/ߊl荞݌Ăі߂֐ݒ
 *
 * ̊֐͊荞݌Ăі߂֐̐ݒƕύXĂяoɋ܂BĂі߂
 * ̐ݒȂŁAײޓ̊荞ݏ͊荞ݗv׸ނ邾
 * B
 *
 * \note ̊֐conf_xcl.hCONFIG_XCL_CALLBACK_ENABLE̎ɂp
 *       \łB
 *
 * \param  callback Ăі߂֐ւ̎Q
 */
void xcl_set_ucc_interrupt_callback(xcl_callback_t callback)
{
	xcl_cc_callback = callback;
}

#endif

/* ! XCLۯKvۂ */
bool xcl_is_synchronous = false;

/**
 * \brief v\B悤XCL TCۯ`Ԑݒ
 *
 * ̊֐͈Ƃēnꂽ̂Ɠ荂\B邽߂XCL 
 * TCۯIڼ޽`Ԑݒ肵܂B̊֐͌`Ԑݒ肳ꂽۂ̌ʂ̕\
 * Ԃ܂B
 *
 * \param  resolution v镪@\
 * \return ʂ̎ۂɌ`Ԑݒ肳ꂽ\
 */
uint32_t xcl_tc_set_resolution(uint32_t resolution)
{
	uint32_t xcl_clk_rate = sysclk_get_peripheral_bus_hz(&XCL);

	if (resolution <= (xcl_clk_rate / 1024)) {
		xcl_tc_source_clock(DIV1024);
		return xcl_clk_rate / 1024;
	} else if (resolution <= (xcl_clk_rate / 256)) {
		xcl_tc_source_clock(DIV256);
		return xcl_clk_rate / 256;
	} else if (resolution <= (xcl_clk_rate / 64)) {
		xcl_tc_source_clock(DIV64);
		return xcl_clk_rate / 64;
	} else if (resolution <= (xcl_clk_rate / 8)) {
		xcl_tc_source_clock(DIV8);
		return xcl_clk_rate / 8;
	} else if (resolution <= (xcl_clk_rate / 4)) {
		xcl_tc_source_clock(DIV4);
		return xcl_clk_rate / 4;
	} else if (resolution <= (xcl_clk_rate / 2)) {
		xcl_tc_source_clock(DIV2);
		return xcl_clk_rate / 2;
	} else {
		xcl_tc_source_clock(DIV1);
		return xcl_clk_rate;
	}
}
